diff --git a/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java b/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
index 12e03ff40..627376011 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -15,6 +14,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
+import net.minecraft.core.util.helper.LightIndexHelper;
 
 public class ItemElement extends Gui {
     Minecraft mc;
@@ -58,7 +58,7 @@ public class ItemElement extends Gui {
             GLRenderer.enableState(State.DEPTH_TEST);
             if (itemStack != null) {
                 final ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-                itemModel.renderGui(GLRenderer.getTessellator(), null, itemStack, x, y, discovered ? LightmapHelper.getLightmapCoord(15, 15) : LightmapHelper.getLightmapCoord(0, 0), 1f);
+                itemModel.renderGui(GLRenderer.getTessellator(), null, itemStack, x, y, discovered ? LightIndexHelper.lightIndex2i(15, 15) : LightIndexHelper.lightIndex2i(0, 0), 1f);
                 if (slot instanceof SlotGuidebook slotGuidebook) {
                     if (slotGuidebook.recipe instanceof RecipeEntryTrommel recipeEntryTrommel && slotGuidebook.item != null && slotGuidebook.isOutput) {
                         final WeightedRandomBag<WeightedRandomLootObject> loot = recipeEntryTrommel.getOutput();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 106f1b9ce..e832d4503 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -11,7 +11,6 @@ import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CullFace;
@@ -26,6 +25,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
@@ -344,7 +344,7 @@ public class ScreenMainMenu extends Screen {
         }
 
         GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.TERRAIN);
+        GLRenderer.setShader(Shaders.ITEM);
         final int delta = this.mc.gameWindow.getWidthPixels() / this.mc.resolution.getScaledWidthScreenCoords();
         int var3 = 120 * delta;
         GLRenderer.projectionM4f().identity().perspective(70.0F, (float) this.mc.gameWindow.getWidthPixels() / (float) var3, 0.05F, 100.0F);
@@ -386,8 +386,8 @@ public class ScreenMainMenu extends Screen {
             TextureRegistry.worldAtlas.bind();
             GL41.glActiveTexture(GL41.GL_TEXTURE2);
             TextureRegistry.worldAtlas.layerTextureMap.get("emissive").bind();
-//        GL41.glActiveTexture(GL41.GL_TEXTURE3);
-//        TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
+            GL41.glActiveTexture(GL41.GL_TEXTURE3);
+            TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
             GL41.glActiveTexture(GL41.GL_TEXTURE0);
             if (renderPass == 0) {
                 this.mc.textureManager.loadTexture("/title/black.png").bind();
@@ -412,7 +412,7 @@ public class ScreenMainMenu extends Screen {
                         GLRenderer.modelM4f().translate(x, y, z);
                         GLRenderer.modelM4f().scale(scale, scale, scale);
                         TessellatorGeneral t = GLRenderer.getTessellator();
-                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(t, 0, LightmapHelper.getLightmapCoord(15, 15));
+                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(t, 0, LightIndexHelper.lightIndex2i(15, 15));
                         GLRenderer.popFrame();
                     }
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
index 055f1240d..56a48dd6d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
@@ -12,6 +11,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Mouse;
@@ -94,7 +94,7 @@ public class ScreenStats extends Screen {
         renderBackgroundIcon(x + 1, y + 1);
         Lighting.enableInventoryLight();
         Item item = Item.itemsList[itemID];
-        ItemModelDispatcher.getInstance().getDispatch(item).renderGui(GLRenderer.getTessellator(), null, item.getDefaultStack(), x + 2, y + 2, LightmapHelper.getLightmapCoord(15, 15), 1f);
+        ItemModelDispatcher.getInstance().getDispatch(item).renderGui(GLRenderer.getTessellator(), null, item.getDefaultStack(), x + 2, y + 2, LightIndexHelper.lightIndex2i(15, 15), 1f);
         Lighting.disable();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index e0a5ada27..ca52ae79e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -29,6 +29,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -888,7 +889,7 @@ public class ScreenAchievements extends Screen
             GLRenderer.modelM4f().translate((float) (achViewX + 3 * zoom), (float) (achViewY + 3 * zoom), 0);
             GLRenderer.modelM4f().scale((float) zoom, (float) zoom, 1);
 //            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
-            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(GLRenderer.getTessellator(), null, achievementItem.getDefaultStack(), 0, 0, LightmapHelper.getLightmapCoord(15, 15), 1f);
+            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(GLRenderer.getTessellator(), null, achievementItem.getDefaultStack(), 0, 0, LightIndexHelper.lightIndex2i(15, 15), 1f);
 
             GLRenderer.globalSetLightEnabled(false);
             GLRenderer.popFrame();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index abfd30032..56c233566 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -9,7 +9,6 @@ import net.minecraft.client.gui.guidebook.search.GuidebookSectionSearch;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.entity.EntityRendererItem;
 import net.minecraft.client.render.font.FontRenderer;
@@ -20,6 +19,7 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
@@ -566,7 +566,7 @@ public class ScreenGuidebook
                 GLRenderer.setColor4f(1, 1, 1, 1);
 
                 GLRenderer.enableState(State.DEPTH_TEST);
-                ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(GLRenderer.getTessellator(), null, icon, this.x + iconOffset + xo, this.y + 4, LightmapHelper.getLightmapCoord(15, 15), 1f);
+                ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(GLRenderer.getTessellator(), null, icon, this.x + iconOffset + xo, this.y + 4, LightIndexHelper.lightIndex2i(15, 15), 1f);
                 GLRenderer.disableState(State.DEPTH_TEST);
 
                 Lighting.disable();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 5982bc4c6..c887c7b46 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -12,12 +12,14 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.HumanArmorShape;
@@ -193,10 +195,15 @@ public class HudIngame extends Gui {
 
                 this.debugOffsetRight += space;
 
-                drawDebugScreenLineRight(GL41.glGetString(GL41.GL_VENDOR));
-                drawDebugScreenLineRight(GL41.glGetString(GL41.GL_RENDERER));
-                drawDebugScreenLineRight(GL41.glGetString(GL41.GL_VERSION));
+                drawDebugScreenLineRight(OpenGLHelper.vendor);
+                drawDebugScreenLineRight(OpenGLHelper.renderer);
+                drawDebugScreenLineRight(OpenGLHelper.version);
                 drawDebugScreenLineRight(String.format("OpenGL %s.%s", GL41.glGetInteger(GL41.GL_MAJOR_VERSION), GL41.glGetInteger(GL41.GL_MINOR_VERSION)));
+                long availableVRam = OpenGLHelper.availableVRam();
+                long totalVRam = OpenGLHelper.totalVRam();
+                if (totalVRam != -1 || availableVRam != -1) {
+                    drawDebugScreenLineRight(String.format("Available Video Memory (%sMB) of %sMB", (availableVRam / 1024), (totalVRam / 1024)));
+                }
                 drawDebugScreenLineRight("Resolution: " + this.mc.gameWindow.getWidthPixels() + "x" + this.mc.gameWindow.getHeightPixels());
                 drawDebugScreenLineRight("Render Resolution: " + this.mc.renderer.getRenderWidth() + "x" + this.mc.renderer.getRenderHeight());
 
@@ -210,7 +217,7 @@ public class HudIngame extends Gui {
                     int playerZ = MathHelper.floor(this.mc.thePlayer.z);
 
 
-                    List<RenderRegion> allRegions = terrainRenderer.regionBuffer.getAllRegions();
+                    List<RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig>> allRegions = terrainRenderer.regionBuffer.getAllRegions();
                     int totalEntries = 0;
                     int visibleEntries = 0;
                     for (int i = 0; i < allRegions.size(); i++) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
index 06a5c0a1b..00bf0254f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
@@ -4,12 +4,12 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.LightIndexHelper;
 
 public class HudComponentArmorDurability
     extends HudComponentMovable {
@@ -45,7 +45,7 @@ public class HudComponentArmorDurability
             if (stack != null) {
                 int xx = x + 2;
                 int yy = y + 48 - i * 16;
-                ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(GLRenderer.getTessellator(), null, stack, xx, yy, LightmapHelper.getLightmapCoord(15, 15), partialTick);
+                ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(GLRenderer.getTessellator(), null, stack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), partialTick);
 //                glDisable(GL_LIGHTING);
 
                 if (stack.isItemStackDamageable()) {
@@ -70,7 +70,7 @@ public class HudComponentArmorDurability
 
             int xx = x + 2;
             int yy = y + 48 - i * 16;
-            ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(GLRenderer.getTessellator(), null, stack, xx, yy, LightmapHelper.getLightmapCoord(15, 15), 0.0f);
+            ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(GLRenderer.getTessellator(), null, stack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), 0.0f);
 //            glDisable(GL_LIGHTING);
 
             if (stack.isItemStackDamageable()) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
index 6c76c10c4..9faa2a7ee 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
@@ -5,12 +5,12 @@ import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.LightIndexHelper;
 
 import java.awt.Color;
 
@@ -72,7 +72,7 @@ public class HudComponentHeldItemCount
                 GLRenderer.enableState(State.DEPTH_TEST);
                 GLRenderer.disableState(State.BLEND);
                 Lighting.enableInventoryLight();
-                ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(GLRenderer.getTessellator(), null, heldItemStack, xx, yy, LightmapHelper.getLightmapCoord(15, 15), partialTick);
+                ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(GLRenderer.getTessellator(), null, heldItemStack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), partialTick);
                 Lighting.disable();
             }
         }
@@ -94,7 +94,7 @@ public class HudComponentHeldItemCount
         GLRenderer.enableState(State.DEPTH_TEST);
         GLRenderer.disableState(State.BLEND);
         Lighting.enableInventoryLight();
-        ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(GLRenderer.getTessellator(), null, heldItemStack, xx, yy, LightmapHelper.getLightmapCoord(15, 15), 0.0f);
+        ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(GLRenderer.getTessellator(), null, heldItemStack, xx, yy, LightIndexHelper.lightIndex2i(15, 15), 0.0f);
         Lighting.disable();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 546d10460..612ca2ed0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -6,7 +6,6 @@ import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
@@ -17,6 +16,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.util.helper.LightIndexHelper;
 
 import static net.minecraft.client.Minecraft.HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
 
@@ -194,7 +194,7 @@ public class HudComponentHotbar
             GLRenderer.modelM4f().translate(-(x + 8), -(y + 12), 0.0F);
         }
 //        itemModel.renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, itemstack, x, y, 1.0f);
-        itemModel.renderGui(GLRenderer.getTessellator(), null, itemstack, x, y, LightmapHelper.getLightmapCoord(15, 15), partialTick);
+        itemModel.renderGui(GLRenderer.getTessellator(), null, itemstack, x, y, LightIndexHelper.lightIndex2i(15, 15), partialTick);
         if (animProgress > 0.0F) {
             GLRenderer.popFrame();
         }
@@ -204,7 +204,7 @@ public class HudComponentHotbar
     private void renderItem(Minecraft mc, ItemStack itemStack, int x, int y) {
         ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
 //        itemModel.renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, itemStack, x, y, 1.0f);
-        itemModel.renderGui(GLRenderer.getTessellator(), null, itemStack, x, y, LightmapHelper.getLightmapCoord(15, 15), 1f);
+        itemModel.renderGui(GLRenderer.getTessellator(), null, itemStack, x, y, LightIndexHelper.lightIndex2i(15, 15), 1f);
         itemModel.renderItemOverlayIntoGUI(GLRenderer.getTessellator(), mc.font, mc.textureManager, itemStack, x, y, null, 1.0f);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
index 95f0b5379..b07d41795 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
@@ -12,6 +12,7 @@ import net.minecraft.core.Global;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL41;
 
@@ -173,7 +174,7 @@ public class GuiElementToastsHud extends Gui {
 
         GLRenderer.enableState(State.DEPTH_TEST);
         ItemStack icon = toast.getIcon(duration);
-        if (icon != null) ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(GLRenderer.getTessellator(), null, icon, x + 8, y + 8, LightmapHelper.getLightmapCoord(15, 15), 1.0f);
+        if (icon != null) ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(GLRenderer.getTessellator(), null, icon, x + 8, y + 8, LightIndexHelper.lightIndex2i(15, 15), 1.0f);
         GLRenderer.disableState(State.DEPTH_TEST);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index bd72be525..242c1cace 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -315,9 +315,9 @@ public abstract class PlayerController {
         final int prevStackSize = stack.stackSize;
         final @Nullable ItemStack newItemStack = stack.useItem(world, player);
         if (newItemStack != stack || newItemStack.stackSize != prevStackSize) {
-            player.inventory.setCurrentItem(newItemStack);
+            player.inventory.setItem(player.inventory.getCurrentSlot(), newItemStack);
             if (newItemStack == null || newItemStack.stackSize <= 0) {
-                player.inventory.setCurrentItem(null);
+                player.inventory.setItem(player.inventory.getCurrentSlot(), null);
             }
 
             return true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
index dcf353d2f..e78da2c76 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
@@ -141,7 +141,7 @@ public final class EntityRendererDispatcher {
         final double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double) partialTick;
         final float lerpYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
 
-        GLRenderer.setLightmapCoord1i(entity.getLightmap(partialTick));
+        GLRenderer.setLightmapCoord1i(entity.getLightIndex(partialTick));
         GLRenderer.setColor3f(1f, 1f, 1f);
         renderEntityWithPosYaw(tessellator, entity, lerpPosX - renderPosX, lerpPosY - renderPosY, lerpPosZ - renderPosZ, lerpYaw, partialTick);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 7c8791428..c6d75ba27 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -50,8 +50,8 @@ public class ItemRenderer {
         ItemStack itemstack = this.itemToRender;
         if (itemstack != null) {
             GLRenderer.setColor4f(1f, 1f, 1f, 1f);
-            GLRenderer.setLightmapCoord1i(this.mc.thePlayer.getLightmap(partialTick));
-            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderFirstPerson(GLRenderer.getTessellator(), this, player, itemstack, player.getLightmap(partialTick), partialTick);
+            GLRenderer.setLightmapCoord1i(this.mc.thePlayer.getLightIndex(partialTick));
+            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderFirstPerson(GLRenderer.getTessellator(), this, player, itemstack, player.getLightIndex(partialTick), partialTick);
         } else {
 
             GLRenderer.pushFrame();
@@ -60,7 +60,7 @@ public class ItemRenderer {
             GLRenderer.enableState(State.DEPTH_TEST);
             GLRenderer.setDepthFunc(CompareFunc.LESS);
             float brightness = 1.0f;
-            GLRenderer.setLightmapCoord1i(this.mc.thePlayer.getLightmap(partialTick));
+            GLRenderer.setLightmapCoord1i(this.mc.thePlayer.getLightIndex(partialTick));
             GLRenderer.setColor4f(brightness, brightness, brightness, 1.0f);
             EntityRenderer<? extends Entity> render = EntityRendererDispatcher.instance.getRenderer(this.mc.thePlayer);
             MobRendererPlayer playerRenderer = (MobRendererPlayer) render;
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index feb36419c..3f7e15b42 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -19,12 +20,12 @@ final public class LightingCache {
     private int opacityCached = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
     private int opacityValue = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
 
-    private int lightmapCoordCached = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
-    private final int[] lightmapCoordValue = new int[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private int lightIndexCached = 0; // new boolean[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
+    private final byte[] lightIndexValue = new byte[CACHE_SIZE * CACHE_SIZE * CACHE_SIZE];
 
     private final @NotNull TilePos offset = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
 
-    private @NotNull Block<?> block;
+    private @NotNull Block<?> block = Blocks.AIR;
     private WorldSource access;
     private final @NotNull TilePos queryPos = new TilePos();
 
@@ -39,7 +40,7 @@ final public class LightingCache {
             this.access = source;
             this.brightnessCached = 0;
             this.opacityCached = 0;
-            this.lightmapCoordCached = 0;
+            this.lightIndexCached = 0;
             this.offset.set(tilePos);
         }
     }
@@ -71,14 +72,14 @@ final public class LightingCache {
         return bitGet(this.opacityValue, index);
     }
 
-    public int getLightmapCoord(int relX, int relY, int relZ) {
+    public byte getLightIndex(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
-        if (!bitGet(this.lightmapCoordCached, index)) {
+        if (!bitGet(this.lightIndexCached, index)) {
             int lightEmission = this.block.emission;
-            this.lightmapCoordValue[index] = this.access.getLightmapCoord(this.offset.add(relX, relY, relZ, this.queryPos), lightEmission);
-            this.lightmapCoordCached = bitSet(this.lightmapCoordCached, index);
+            this.lightIndexValue[index] = this.access.getLightIndex(this.offset.add(relX, relY, relZ, this.queryPos), lightEmission);
+            this.lightIndexCached = bitSet(this.lightIndexCached, index);
         }
-        return this.lightmapCoordValue[index];
+        return this.lightIndexValue[index];
     }
 
     private static boolean bitGet(int value, int index) {
